close all
clear all
clc

load cameraman.mat
load cameraman_cs.mat
load flou.mat
load laplacien.mat
load decimation.mat

%% TP1 : Question 4
[n,m] = size(D);
ind = find(D~=0);
lambda=0.1;
gamma=1.9/(2*1+ 2 *lambda*16);
critere =@(x) norm(op_direct_decimated(x,H,ind) - y,'fro')^2 + lambda*norm(op_direct(reshape(x,n,m),G))^2;
gradient =@(x) 2*op_adjoint_decimated(op_direct_decimated(x,H,ind) - y,H,ind)  + 2*lambda*reshape(op_adjoint(op_direct(reshape(x,n,m),G),G),1,n*m);


% Gradient descent
xi = op_adjoint_decimated(y,H,ind);
for i=1 : 100
    xi = xi - gamma*gradient(xi);
    crit(i) = critere(xi);  
end

% Print figure
figure(1);
yD = zeros(n,m);
yD(ind) = y;
subplot(131); imagesc(yD); axis image off; colormap(gray);
title 'degraded data'
subplot(132); imagesc(reshape(xi,n,n)); axis image off; colormap(gray);
title 'restored data'
subplot(133); semilogy(crit); grid on; title 'Criterion'

